//
//  MTLTabView.m
//  EnablerTest
//
//  Created by narita on 2013/01/23.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "MTLTabView.h"

@implementation MTLTabView

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

#pragma -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark action & canAction methods

#pragma mark -
#pragma mark delegate/datasource methods

- (void)viewDidMoveToWindow
{
    [super viewDidMoveToWindow];
    
    NSWindow* theWindow = [self window];
    
    if( theWindow != nil )
    {
        [[NSNotificationCenter defaultCenter] addObserver:self
                                                 selector:@selector(updateEnableState)
                                                     name:NSWindowDidUpdateNotification
                                                   object:theWindow];
    }
}

- (void)viewWillMoveToWindow:(NSWindow *)newWindow
{
    [super viewWillMoveToWindow:newWindow];
    
    NSWindow* theWindow = [self window];
    
    if( theWindow != nil )
    {
        [[NSNotificationCenter defaultCenter] removeObserver:self
                                                        name:NSWindowDidUpdateNotification
                                                      object:theWindow];
    }
    
}

#pragma mark -
#pragma mark accessor methods (in pairs)

- (void)setActionName:(NSString*)inActionName
{
    self.action = NSSelectorFromString(inActionName);
}

- (NSString*)actionName
{
    return NSStringFromSelector(_action);
}

- (NSInteger) selectedTag
{
    return [[[self selectedTabViewItem] identifier] integerValue];
}

#pragma mark -
#pragma mark Utility methods

/*!
 @method     updateEnableState
 @abstract   enabledの値をtarget-actionを参考にアップデートする
 @discussion
 */
- (void) updateEnableState
{
    
}


@end
