//
//  ETAppDelegate.m
//  EnablerTest
//
//  Created by narita on 2013/01/03.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "ETAppDelegate.h"
#import "NSObject(MTLControlItemEnabler).h"
#import "MTLPreferencesWindowController.h"

@implementation ETAppDelegate

- (void)dealloc
{
    [super dealloc];
}

// delegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
    
    enableNumber = 1;
    radioBtnNumber = 2;
}

- (void)applicationDidUpdate:(NSNotification *)notification
{
    [[NSApp mainMenu] update];
}


- (void) enableNumberIncrement
{
    enableNumber ++;
    
    if( enableNumber == 4)
    {
        enableNumber = 1;
    }
}

/////////

- (IBAction) showPreferenceWindow:(id)sender
{
	[[MTLPreferencesWindowController sharedPreference] showWindow:self];
}

- (BOOL) canShowPreferenceWindow
{
	return ([[[MTLPreferencesWindowController sharedPreference] window] isMainWindow] == NO);
}

///////// appDelegateAction1まわり

- (IBAction) appDelegateAction1:(id)sender
{
    [self enableNumberIncrement];
}

- (BOOL) canAppDelegateAction1:(id)anItem
{
    return ( enableNumber == 1 );
}

- (NSString*) titleOfAppDelegateAction1:(NSObject<NSValidatedUserInterfaceItem>*)anItem
{
    return [NSString stringWithFormat:@"enable(%li)", enableNumber];
}

- (NSString*) labelOfAppDelegateAction1:(NSObject<NSValidatedUserInterfaceItem>*)anItem
{
    return [NSString stringWithFormat:@"label(%li)", enableNumber];
}

///////// appDelegateAction2まわり

- (IBAction) appDelegateAction2:(id)sender
{
    [self enableNumberIncrement];
}

- (BOOL) canAppDelegateAction2:(id)anItem
{
    return ( enableNumber == 2 );
}

- (NSImage*) imageOfAppDelegateAction2:(id)anItem
{
    switch (enableNumber)
    {
        case 1:
            return [NSImage imageNamed:NSImageNameIconViewTemplate];
            break;
            
        case 2:
            return [NSImage imageNamed:NSImageNameListViewTemplate];
            break;
            
        case 3:
            return [NSImage imageNamed:NSImageNameColumnViewTemplate];
            break;
            
        default:
            return nil;
            break;
    }
}

///////// appDelegateAction3まわり

- (IBAction) appDelegateAction3:(id)sender
{
    NSLog(@"appDelegateAction3");
    [self enableNumberIncrement];
}

- (BOOL) canAppDelegateAction3:(id)anItem
{
    return ( enableNumber == 3 );
}

- (NSInteger) stateOfAppDelegateAction3:(id)anItem // チェックマークのon/off/mixを制御
{
    switch (enableNumber)
    {
        case 1:
            return NSOnState;
            break;

        case 2:
            return NSOffState;
            break;

        case 3:
            return NSMixedState;
            break;

        default:
            return NSMixedState;
            break;
    }
}

// Radioボタンとか

- (IBAction) radioBtnAction:(id<MTLControlItemEnablerProtocol>)sender
{    
    radioBtnNumber = [sender selectedTag];
}


- (NSInteger) stateOfRadioBtnAction:(id<MTLControlItemEnablerProtocol>)anItem
{    
    if ( [anItem selectedTag] == radioBtnNumber )
        return NSOnState;
    else
        return NSOffState;
}



/////////

- (BOOL)validateUserInterfaceItem:(NSObject<NSValidatedUserInterfaceItem>*)anItem
{    
	return [self controlItemEnabler:anItem];
}

@end
